.586
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE

INCLUDE windows.inc

INCLUDE kernel32.inc
INCLUDE user32.inc
INCLUDE msvcrt.inc
INCLUDE masm32.inc

INCLUDE c:\masm32\macros\macros.asm

INCLUDELIB kernel32.lib
INCLUDELIB user32.lib
INCLUDELIB msvcrt.lib
INCLUDELIB masm32.lib

main PROTO
ShowBytes PROTO pqwBytes:PTR QWORD

.DATA

    ; Maximum signed QWORD (7FFFFFFFFFFFFFFFh) = 8 exbibytes
    ALIGN 8
    ;qwBytes QWORD 0                  ; 0 bytes
    ;qwBytes QWORD 123                ; 123 bytes
    ;qwBytes QWORD 24576              ; 24 kB
    ;qwBytes QWORD 167772160          ; 160 MB
    ;qwBytes QWORD 21474836480        ; 2.0 GB
    qwBytes QWORD 1649267441664      ; 1.5 TB
    ;qwBytes QWORD 225179981368524800  ; 200 PB
    ;qwBytes QWORD 9223372036854775807 ; 8 EB

.CODE

start:

    call main
    inkey SADD(13,10,"Press any key to exit ... ")
    INVOKE ExitProcess, eax

main PROC

    finit
    INVOKE ShowBytes, ADDR qwBytes
    INVOKE StdOut, chr$(13,10)

    ret
main ENDP

ShowBytes PROC pqwBytes:PTR QWORD

    ALIGN 8
    LOCAL tmpReal8:REAL8
    LOCAL hibit:DWORD

    .DATA

        ALIGN 8
        qwEBi   REAL8 8.67361737988404E-19
        qwPBi   REAL8 8.88178419700125E-16
        qwTBi   REAL8 9.09494701772928E-13
        qwGBi   REAL8 9.31322574615479E-10
        qwMBi   REAL8 9.5367431640625E-07
        qwKBi   REAL8 0.0009765625

        psz     PBYTE szB

        szB     BYTE "bytes",0
        szkB    BYTE "kB",0
        szMB    BYTE "MB",0
        szGB    BYTE "GB",0
        szTB    BYTE "TB",0
        szPB    BYTE "PB",0
        szEB    BYTE "EB",0

    .CODE

        ; put a finit somewhere
        mov edx, pqwBytes
        fild QWORD PTR [edx]
        bsr eax, [edx+4]
        jz lodword
        add eax, 32
        mov hibit, eax
        jmp gothibit
      lodword:
        bsr eax, [edx]
        jz done
        mov hibit, eax
      gothibit:
        .IF hibit < 10
            jmp done
        .ELSEIF hibit < 20
            fmul qwKBi
            mov psz, OFFSET szkB
        .ELSEIF hibit < 30
            fmul qwMBi
            mov psz, OFFSET szMB
        .ELSEIF hibit < 40
            fmul qwGBi
            mov psz, OFFSET szGB
        .ELSEIF hibit < 50
            fmul qwTBi
            mov psz, OFFSET szTB
        .ELSEIF hibit < 60
            fmul qwPBi
            mov psz, OFFSET szPB
        .ELSE
            fmul qwEBi
            mov psz, OFFSET szEB
        .ENDIF
      done:
        fstp tmpReal8
        INVOKE crt_printf, chr$("%.2lf %s"), tmpReal8, psz
        ret
ShowBytes ENDP

END start

